Index: issm/branches/trunk-jpl-damage/src/c/modules/Gradjx/Gradjx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Gradjx/Gradjx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Gradjx/Gradjx.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/GroundinglineMigrationx/GroundinglineMigrationx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/GroundinglineMigrationx/GroundinglineMigrationx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/GroundinglineMigrationx/GroundinglineMigrationx.cpp	(revision 12878)
@@ -20,5 +20,5 @@
 	Element* element                          = NULL;
 	
-	_printf_(VerboseModule(),"   Migrating grounding line\n");
+	if(VerboseModule()) _pprintLine_("   Migrating grounding line");
 	
 	/*retrieve parameters: */
@@ -27,5 +27,5 @@
 
 	if(migration_style==NoneEnum) return;
-	if(migration_style!=AgressiveMigrationEnum && migration_style!=SoftMigrationEnum) _error_("%s not supported yet!",EnumToStringx(migration_style));
+	if(migration_style!=AgressiveMigrationEnum && migration_style!=SoftMigrationEnum) _error2_(EnumToStringx(migration_style) << " not supported yet!");
 
 	if(migration_style==SoftMigrationEnum){
@@ -49,10 +49,10 @@
 	/*free ressouces: */
 	xdelete(&vec_old_floatingice);
-	xfree((void**)&vertices_potentially_ungrounding);
-	xfree((void**)&vertices_ungrounding);
-	xfree((void**)&old_floatingice);
+	xDelete<double>(vertices_potentially_ungrounding);
+	xDelete<double>(vertices_ungrounding);
+	xDelete<double>(old_floatingice);
 }
 
-/*FUNCTION CreateNodesOnFloatingIce {{{1*/
+/*FUNCTION CreateNodesOnFloatingIce {{{*/
 Vector* CreateNodesOnFloatingIce(Nodes* nodes,int configuration_type){ 
 
@@ -81,5 +81,5 @@
 }
 /*%}}}*/
-/*FUNCTION PotentialSheetUngrounding {{{1*/
+/*FUNCTION PotentialSheetUngrounding {{{*/
 double*    PotentialSheetUngrounding(Elements* elements,Vertices* vertices,Parameters* parameters){ 
 
@@ -108,5 +108,5 @@
 }
 /*}}}*/
-/*FUNCTION PropagateFloatingiceToGroundedNeighbors {{{1*/
+/*FUNCTION PropagateFloatingiceToGroundedNeighbors {{{*/
 double*    PropagateFloatingiceToGroundedNeighbors(Elements* elements,Nodes* nodes,Vertices* vertices,Parameters* parameters,double* vertices_potentially_ungrounding){ 
 
@@ -158,5 +158,5 @@
 		#ifdef _HAVE_MPI_
 		MPI_Allreduce(&local_nflipped,&nflipped,1,MPI_INT,MPI_SUM,MPI_COMM_WORLD);
-		_printf_(VerboseConvergence(),"   Additional number of vertices allowed to unground: %i\n",nflipped);
+		if(VerboseConvergence()) _pprintLine_("   Additional number of vertices allowed to unground: " << nflipped);
 		#else
 		nflipped=local_nflipped;
@@ -164,6 +164,6 @@
 
 		/*Avoid leaks: */
-		xfree((void**)&elements_neighboring_floatingce);
-		xfree((void**)&nodes_on_floatingice);
+		xDelete<double>(elements_neighboring_floatingce);
+		xDelete<double>(nodes_on_floatingice);
 
 		/*Assemble and serialize:*/
@@ -174,5 +174,5 @@
 	/*Free ressources:*/
 	xdelete(&vec_nodes_on_floatingice);
-	xfree((void**)&elements_neighboring_floatingce);
+	xDelete<double>(elements_neighboring_floatingce);
 
 	return nodes_on_floatingice;
Index: issm/branches/trunk-jpl-damage/src/c/modules/HoleFillerx/HoleFillerx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/HoleFillerx/HoleFillerx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/HoleFillerx/HoleFillerx.cpp	(revision 12878)
@@ -43,5 +43,5 @@
 
 	 /*^^^^^^^^^^^^^  Remove pixels close to the holes ^^^^^^^^^^^^^*/
-	image2 = (double*) xmalloc( lines*samps*sizeof(double));
+	image2 = xNew<double>(lines*samps);
 	memcpy(image2,image,lines*samps*sizeof(double));
 	
@@ -64,5 +64,5 @@
 	}
 
-	image3 = (double*) xmalloc( lines*samps*sizeof(double));
+	image3 = xNew<double>(lines*samps);
 	memcpy(image3,image2,lines*samps*sizeof(double));
 
@@ -76,6 +76,6 @@
 			}
 		}
-		printf( "\n" );
-		printf("Number of zeroes remaining: %10ld",lines*samps-counter);
+		_printLine_( "" );
+		_printString_("Number of zeroes remaining: " << lines*samps-counter);
 		fflush( stdout );
 	#endif
@@ -95,6 +95,6 @@
 		}
 		//        n u m b e r   o f   z e r o e s   r e m a i n i n g :   1 2 3 4 5 6 7 8 9 10        
-		printf( "\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b" );
-		printf("Number of zeroes remaining: %10ld",lines*samps-counter);
+		_printString_( "\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b" );
+		_printString_("Number of zeroes remaining: " << lines*samps-counter);
 		fflush( stdout );
 	#endif
@@ -104,5 +104,5 @@
 /***************** FIRST RUN *********************/
 /*
-fprintf ( stdout, "First  Application:  " ); time(&t2); printf( ctime(&t2) );
+fprintf ( stdout, "First  Application:  " ); time(&t2); _printString_( ctime(&t2) );
 */
 	for ( i = 0; i < lines; i++ ){
@@ -277,5 +277,5 @@
 			
 			#ifdef _DEBUG2_
-				//printf("%g %g %g \n",temp,elev,range);
+				//_printLine_(temp << " " << elev << " " << range << " ");
 			#endif
 
@@ -304,5 +304,5 @@
 /************************ SMOOTH THE RESULT ***********************/		
 		
-	image4 = (double*) xmalloc( lines*samps*sizeof(double));
+	image4 = xNew<double>(lines*samps);
 	memcpy(image4,image3,lines*samps*sizeof(double));
 
@@ -348,5 +348,5 @@
 
 	/*Allocate output image: */
-	imageout=(double*)xmalloc(samps*lines*sizeof(double));
+	imageout=xNew<double>(samps*lines);
 	memcpy(imageout,image3,lines*samps*sizeof(double));
 
@@ -354,6 +354,6 @@
 	
 	#ifdef _DEBUG2_
-		printf( "\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b" );
-		printf("Number of zeroes remaining:          0\n\n");
+		_printString_( "\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b" );
+		_printLine_("Number of zeroes remaining:          0\n");
 		printf ( "\n");
 	#endif
@@ -363,6 +363,4 @@
 	/*Assign output pointers: */
 	*pimageout=imageout;
-
 	return 1;
-	
 }
Index: issm/branches/trunk-jpl-damage/src/c/modules/IceVolumex/IceVolumex.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/IceVolumex/IceVolumex.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/IceVolumex/IceVolumex.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/InputArtificialNoisex/InputArtificialNoisex.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/InputArtificialNoisex/InputArtificialNoisex.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/InputArtificialNoisex/InputArtificialNoisex.cpp	(revision 12878)
@@ -9,5 +9,5 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 
-void InputArtificialNoisex( Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,int enum_name,double min,double max){
+void InputArtificialNoisex( Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,int enum_name,IssmDouble min,IssmDouble max){
 
 	int i;
Index: issm/branches/trunk-jpl-damage/src/c/modules/InputArtificialNoisex/InputArtificialNoisex.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/InputArtificialNoisex/InputArtificialNoisex.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/InputArtificialNoisex/InputArtificialNoisex.h	(revision 12878)
@@ -6,9 +6,9 @@
 #define _INPUTARTIFICIALNOISEX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Container.h"
 
 /* local prototypes: */
-void	InputArtificialNoisex( Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,int enum_name,double min,double max);
+void	InputArtificialNoisex( Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,int enum_name,IssmDouble min,IssmDouble max);
 
 #endif  /* _UPDATEINPUTSFROMVECTORXX_H */
Index: issm/branches/trunk-jpl-damage/src/c/modules/InputConvergencex/InputConvergencex.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/InputConvergencex/InputConvergencex.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/InputConvergencex/InputConvergencex.cpp	(revision 12878)
@@ -9,16 +9,16 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 
-bool InputConvergencex(Elements* elements,Nodes* nodes,Vertices* vertices,Loads* loads,Materials* materials,Parameters* parameters,int* enums, int num_enums, int* criterionenums, double* criterionvalues,int num_criterionenums){
+bool InputConvergencex(Elements* elements,Nodes* nodes,Vertices* vertices,Loads* loads,Materials* materials,Parameters* parameters,int* enums, int num_enums, int* criterionenums, IssmDouble* criterionvalues,int num_criterionenums){
 
 	/*intermediary:*/
-	int         i;
-	bool        converged;
-	int         num_notconverged=0;
-	int         total_notconverged;
-	double     *eps       = NULL;
-	Element*    element=NULL;
+	int      i;
+	bool     converged;
+	int      num_notconverged   = 0;
+	int      total_notconverged;
+	IssmDouble  *eps                = NULL;
+	Element *element            = NULL;
 
 	/*allocate dynamic memory: */
-	eps=(double*)xmalloc(num_criterionenums*sizeof(double));
+	eps=xNew<IssmDouble>(num_criterionenums);
 
 	/*Go through elements, and ask them to do the job: */
@@ -34,8 +34,8 @@
 	num_notconverged=total_notconverged;
 	#endif
-	_printf_(VerboseConvergence(),"      #elements above convergence criterion = %i\n",num_notconverged);
+	if(VerboseConvergence()) _pprintLine_("      #elements above convergence criterion = " << num_notconverged);
 
 	/*Free ressources:*/
-	xfree((void**)&eps);
+	xDelete<IssmDouble>(eps);
 
 	/*return: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/InputConvergencex/InputConvergencex.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/InputConvergencex/InputConvergencex.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/InputConvergencex/InputConvergencex.h	(revision 12878)
@@ -8,5 +8,5 @@
 
 /* local prototypes: */
-bool InputConvergencex(Elements* elements,Nodes* nodes,Vertices* vertices,Loads* loads,Materials* materials,Parameters* parameters,int* enums, int num_enums, int* criterionenums, double* criterionvalues,int num_criterionenums);
+bool InputConvergencex(Elements* elements,Nodes* nodes,Vertices* vertices,Loads* loads,Materials* materials,Parameters* parameters,int* enums, int num_enums, int* criterionenums, IssmDouble* criterionvalues,int num_criterionenums);
 
 #endif  /* _INPUTCONVERGENCEX_H */
Index: issm/branches/trunk-jpl-damage/src/c/modules/InputScalex/InputScalex.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/InputScalex/InputScalex.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/InputScalex/InputScalex.cpp	(revision 12878)
@@ -9,5 +9,5 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 
-void InputScalex(Elements* elements,Nodes* nodes,Vertices* vertices,Loads* loads,Materials* materials,Parameters* parameters,int enum_type, double scale_factor){
+void InputScalex(Elements* elements,Nodes* nodes,Vertices* vertices,Loads* loads,Materials* materials,Parameters* parameters,int enum_type, IssmDouble scale_factor){
 
 	/*intermediary:*/
Index: issm/branches/trunk-jpl-damage/src/c/modules/InputScalex/InputScalex.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/InputScalex/InputScalex.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/InputScalex/InputScalex.h	(revision 12878)
@@ -9,5 +9,5 @@
 
 /* local prototypes: */
-void InputScalex(Elements* elements,Nodes* nodes,Vertices* vertices,Loads* loads,Materials* materials,Parameters* parameters,int enum_type, double scale_factor);
+void InputScalex(Elements* elements,Nodes* nodes,Vertices* vertices,Loads* loads,Materials* materials,Parameters* parameters,int enum_type, IssmDouble scale_factor);
 
 #endif  /* _SCALEINPUTX_H */
Index: issm/branches/trunk-jpl-damage/src/c/modules/InputToResultx/InputToResultx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/InputToResultx/InputToResultx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/InputToResultx/InputToResultx.cpp	(revision 12878)
@@ -13,5 +13,5 @@
 	/*intermediary:*/
 	int      step;
-	double   time;
+	IssmDouble   time;
 	Element *element = NULL;
 
Index: issm/branches/trunk-jpl-damage/src/c/modules/InputUpdateFromConstantx/InputUpdateFromConstantx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/InputUpdateFromConstantx/InputUpdateFromConstantx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/InputUpdateFromConstantx/InputUpdateFromConstantx.cpp	(revision 12878)
@@ -49,5 +49,5 @@
 	}
 }
-void InputUpdateFromConstantx( Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,double constant, int name){
+void InputUpdateFromConstantx( Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,IssmDouble constant, int name){
 
 	int i;
Index: issm/branches/trunk-jpl-damage/src/c/modules/InputUpdateFromConstantx/InputUpdateFromConstantx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/InputUpdateFromConstantx/InputUpdateFromConstantx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/InputUpdateFromConstantx/InputUpdateFromConstantx.h	(revision 12878)
@@ -6,5 +6,5 @@
 #define _UPDATEINPUTSFROMCONSTANTXX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Container.h"
 
@@ -12,5 +12,5 @@
 void		InputUpdateFromConstantx( Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters, bool   constant, int name);
 void		InputUpdateFromConstantx( Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters, int    constant, int name);
-void		InputUpdateFromConstantx( Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters, double constant, int name);
+void		InputUpdateFromConstantx( Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters, IssmDouble constant, int name);
 
 #endif  /* _UPDATEINPUTSFROMCONSTANTXX_H */
Index: issm/branches/trunk-jpl-damage/src/c/modules/InputUpdateFromDakotax/InputUpdateFromDakotax.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/InputUpdateFromDakotax/InputUpdateFromDakotax.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/InputUpdateFromDakotax/InputUpdateFromDakotax.cpp	(revision 12878)
@@ -21,7 +21,7 @@
 	double *qmu_part  = NULL;
 
-	double* distributed_values=NULL;
-	double* parameter=NULL;
-	char*   descriptor=NULL;
+	double *distributed_values = NULL;
+	double *parameter          = NULL;
+	char   *descriptor         = NULL;
 	char    root[50]; //root name of variable, ex: DragCoefficent, RhoIce, etc ...
 
@@ -49,5 +49,5 @@
 
 
-			distributed_values=(double*)xmalloc(npart*sizeof(double));
+			distributed_values=xNew<double>(npart);
 			for(j=0;j<npart;j++){
 				distributed_values[j]=variables[i+j];
@@ -91,12 +91,12 @@
 
 			/*Free allocations: */
-			xfree((void**)&parameter);
-			xfree((void**)&distributed_values);
+			xDelete<double>(parameter);
+			xDelete<double>(distributed_values);
 		}
 		else if (strncmp(descriptor,"indexed_",8)==0){
-			_error_(" indexed variables not supported yet!");
+			_error2_("indexed variables not supported yet!");
 		}
 		else if (strncmp(descriptor,"nodal_",8)==0){
-			_error_(" nodal variables not supported yet!");
+			_error2_("nodal variables not supported yet!");
 		}
 		else{
@@ -107,5 +107,4 @@
 
 	/*Free ressources:*/
-	xfree((void**)&qmu_part);
-
+	xDelete<double>(qmu_part);
 }
Index: issm/branches/trunk-jpl-damage/src/c/modules/InputUpdateFromDakotax/InputUpdateFromDakotax.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/InputUpdateFromDakotax/InputUpdateFromDakotax.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/InputUpdateFromDakotax/InputUpdateFromDakotax.h	(revision 12878)
@@ -6,5 +6,5 @@
 #define _INPUTUPDATEFROMDAKOTAXX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Container.h"
 
Index: issm/branches/trunk-jpl-damage/src/c/modules/InputUpdateFromMatrixDakotax/InputUpdateFromMatrixDakotax.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/InputUpdateFromMatrixDakotax/InputUpdateFromMatrixDakotax.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/InputUpdateFromMatrixDakotax/InputUpdateFromMatrixDakotax.h	(revision 12878)
@@ -6,5 +6,5 @@
 #define _UPDATEINPUTSFROMMATRIXDAKOTAXX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Container.h"
 
Index: issm/branches/trunk-jpl-damage/src/c/modules/InputUpdateFromSolutionx/InputUpdateFromSolutionx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/InputUpdateFromSolutionx/InputUpdateFromSolutionx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/InputUpdateFromSolutionx/InputUpdateFromSolutionx.cpp	(revision 12878)
@@ -11,5 +11,5 @@
 void InputUpdateFromSolutionx( Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,Vector* solution){
 
-	double* serial_solution=NULL;
+	IssmDouble* serial_solution=NULL;
 
 	/*Serialize solution, so that elements can index into it on every CPU: */
@@ -20,10 +20,9 @@
 
 	/*Free ressources:*/
-	xfree((void**)&serial_solution);
-
+	xDelete<IssmDouble>(serial_solution);
 }
 
 
-void InputUpdateFromSolutionx( Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,double* solution){
+void InputUpdateFromSolutionx( Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,IssmDouble* solution){
 
 	/*Intermediary*/
@@ -36,4 +35,3 @@
 		element->InputUpdateFromSolution(solution);
 	}
-
 }
Index: issm/branches/trunk-jpl-damage/src/c/modules/InputUpdateFromSolutionx/InputUpdateFromSolutionx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/InputUpdateFromSolutionx/InputUpdateFromSolutionx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/InputUpdateFromSolutionx/InputUpdateFromSolutionx.h	(revision 12878)
@@ -6,14 +6,14 @@
 #define _UPDATEINPUTSFROMSOLUTIONXX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Container.h"
 
 /* local prototypes: */
 void		InputUpdateFromSolutionx( Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,Vector* solution);
-void        InputUpdateFromSolutionx( Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,double* solution);
+void        InputUpdateFromSolutionx( Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,IssmDouble* solution);
 
 //with timestep
 void		InputUpdateFromSolutionx( Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,Vector* solution,int timestep);
-void        InputUpdateFromSolutionx( Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,double* solution, int timestep);
+void        InputUpdateFromSolutionx( Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,IssmDouble* solution, int timestep);
 
 #endif  /* _UPDATEINPUTSFROMSOLUTIONXX_H */
Index: issm/branches/trunk-jpl-damage/src/c/modules/InputUpdateFromVectorDakotax/InputUpdateFromVectorDakotax.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/InputUpdateFromVectorDakotax/InputUpdateFromVectorDakotax.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/InputUpdateFromVectorDakotax/InputUpdateFromVectorDakotax.cpp	(revision 12878)
@@ -18,5 +18,5 @@
 
 	/*Free ressources:*/
-	xfree((void**)&serial_vector);
+	xDelete<double>(serial_vector);
 }
 
Index: issm/branches/trunk-jpl-damage/src/c/modules/InputUpdateFromVectorDakotax/InputUpdateFromVectorDakotax.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/InputUpdateFromVectorDakotax/InputUpdateFromVectorDakotax.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/InputUpdateFromVectorDakotax/InputUpdateFromVectorDakotax.h	(revision 12878)
@@ -6,5 +6,5 @@
 #define _UPDATEINPUTSFROMVECTORDAKOTAXX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Container.h"
 
Index: issm/branches/trunk-jpl-damage/src/c/modules/InputUpdateFromVectorx/InputUpdateFromVectorx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/InputUpdateFromVectorx/InputUpdateFromVectorx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/InputUpdateFromVectorx/InputUpdateFromVectorx.cpp	(revision 12878)
@@ -11,5 +11,5 @@
 void InputUpdateFromVectorx( Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,Vector* vector, int name, int type){
 
-	double* serial_vector=NULL;
+	IssmDouble* serial_vector=NULL;
 
 	serial_vector=vector->ToMPISerial();
@@ -18,9 +18,9 @@
 
 	/*Free ressources:*/
-	xfree((void**)&serial_vector);
+	xDelete<IssmDouble>(serial_vector);
 }
 
 	
-void InputUpdateFromVectorx( Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,double* vector, int name, int type){
+void InputUpdateFromVectorx( Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,IssmDouble* vector, int name, int type){
 
 	int i;
Index: issm/branches/trunk-jpl-damage/src/c/modules/InputUpdateFromVectorx/InputUpdateFromVectorx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/InputUpdateFromVectorx/InputUpdateFromVectorx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/InputUpdateFromVectorx/InputUpdateFromVectorx.h	(revision 12878)
@@ -6,10 +6,10 @@
 #define _UPDATEINPUTSFROMVECTORXX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Container.h"
 
 /* local prototypes: */
 void	InputUpdateFromVectorx( Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,Vector* vector, int name,int type);
-void	InputUpdateFromVectorx( Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,double* vector, int name,int type);
+void	InputUpdateFromVectorx( Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,IssmDouble* vector, int name,int type);
 void	InputUpdateFromVectorx( Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,int* vector, int name,int type);
 void	InputUpdateFromVectorx( Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,bool* vector, int name,int type);
Index: issm/branches/trunk-jpl-damage/src/c/modules/InterpFromGridToMeshx/InterpFromGridToMeshx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/InterpFromGridToMeshx/InterpFromGridToMeshx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/InterpFromGridToMeshx/InterpFromGridToMeshx.cpp	(revision 12878)
@@ -13,4 +13,5 @@
 #include "../../shared/shared.h"
 #include "../../include/include.h"
+#include "../../io/io.h"
 /*}}}*/
 
@@ -36,11 +37,11 @@
 	/*Some checks on arguments: */
 	if ((M<2) || (N<2) || (nods<=0)){
-		_error_("nothing to be done according to the dimensions of input matrices and vectors.");
+		_error2_("nothing to be done according to the dimensions of input matrices and vectors.");
 	}
 	if (x_in[1]-x_in[0]<0){
-		_error_("x coordinate vector should be increasing.\n   use Matlab's command x=flipud(x), also flip the data matrix data=fliplr(data)");
+		_error2_("x coordinate vector should be increasing.\n   use Matlab's command x=flipud(x), also flip the data matrix data=fliplr(data)");
 	}
 	if (y_in[1]-y_in[0]<0){
-		_error_("y coordinate vector should be increasing.\n   use Matlab's command y=flipud(y), also flip the data matrix data=flipud(data)");
+		_error2_("y coordinate vector should be increasing.\n   use Matlab's command y=flipud(y), also flip the data matrix data=flipud(data)");
 	}
 
@@ -52,6 +53,6 @@
 
 		/*The coordinates given in input describe the contour of each pixel. Take the center of each pixel*/
-		x=(double*)xmalloc(N*sizeof(double));
-		y=(double*)xmalloc(M*sizeof(double));
+		x=xNew<double>(N);
+		y=xNew<double>(M);
 		for (i=0;i<N;i++) x[i]=(x_in[i]+x_in[i+1])/2;
 		for (i=0;i<M;i++) y[i]=(y_in[i]+y_in[i+1])/2;
@@ -62,11 +63,11 @@
 
 		/*The coordinates given in input describe the center each pixel. Keep them*/
-		x=(double*)xmalloc(N*sizeof(double));
-		y=(double*)xmalloc(M*sizeof(double));
+		x=xNew<double>(N);
+		y=xNew<double>(M);
 		for (i=0;i<N;i++) x[i]=x_in[i];
 		for (i=0;i<M;i++) y[i]=y_in[i];
 	}
 	else{
-		_error_("x and y vectors length should be 1 or 0 more than data number of rows.");
+		_error2_("x and y vectors length should be 1 or 0 more than data number of rows.");
 	}
 
@@ -81,10 +82,12 @@
 	gate.data_mesh=data_mesh;
 	gate.data=data;
+	gate.default_value=default_value;
+	gate.interp=interpenum;
 	gate.M=M;
 	gate.N=N;
-	gate.interp=interpenum;
 
 	/*launch the thread manager with InterpFromGridToMeshxt as a core: */
 	LaunchThread(InterpFromGridToMeshxt,(void*)&gate,num);
+	_printLine_("\r      interpolation progress: "<<fixed<<setw(6)<<setprecision(2)<<100.<<"%");
 
 	/*Assign output pointers:*/
@@ -92,5 +95,5 @@
 }
 /*}}}*/
-/*InterpFromGridToMeshxt {{{1*/
+/*InterpFromGridToMeshxt {{{*/
 void* InterpFromGridToMeshxt(void* vpthread_handle){
 
@@ -124,5 +127,5 @@
 	double *y             = gate->y;
 	int     nods          = gate->nods;
-	Vector*     data_mesh     = gate->data_mesh;
+	Vector *data_mesh     = gate->data_mesh;
 	double *data          = gate->data;
 	double  default_value = gate->default_value;
@@ -131,8 +134,13 @@
 	int     N             = gate->N;
 
+	bool debug = M*N>1? true:false;
+	debug = true;
+
 	/*partition loop across threads: */
 	PartitionRange(&i0,&i1,nods,num_threads,my_thread);
 	for (i=i0;i<i1;i++) {
 
+		if(debug && my_thread==0)
+		 _printString_("\r      interpolation progress: "<<setw(6)<<setprecision(2)<<double(i-i0)/double(i1-i0)*100<<"%");
 		x_grid=*(x_mesh+i);
 		y_grid=*(y_mesh+i);
@@ -170,8 +178,8 @@
 					break;
 				default:
-					printf("Interpolation %s not supported yet\n",EnumToStringx(interpenum));
+					_printLine_("Interpolation " << EnumToStringx(interpenum) << " not supported yet");
 					return NULL; /*WARNING: no error because it would blow up the multithreading!*/
 			}
-			if(isnan(data_value)) data_value=default_value;
+			if(xIsNan<IssmDouble>(data_value)) data_value=default_value;
 		}
 		else{
@@ -183,5 +191,5 @@
 }/*}}}*/
 
-/*findindices {{{1*/
+/*findindices {{{*/
 bool findindices(int* pn,int* pm,double* x,int x_rows, double* y,int y_rows, double xgrid,double ygrid){
 
@@ -218,5 +226,5 @@
 	return (foundx && foundy);
 }/*}}}*/
-/*triangleinterp{{{1*/
+/*triangleinterp{{{*/
 double triangleinterp(double x1,double x2,double y1,double y2,double Q11,double Q12,double Q21,double Q22,double x,double y){
 	/*split the rectangle in 2 triangle and
@@ -259,5 +267,5 @@
 	}
 }/*}}}*/
-/*bilinearinterp{{{1*/
+/*bilinearinterp{{{*/
 double bilinearinterp(double x1,double x2,double y1,double y2,double Q11,double Q12,double Q21,double Q22,double x,double y){
 	/*Bilinear  interpolation: (http://en.wikipedia.org/wiki/Bilinear_interpolation) */
@@ -286,5 +294,5 @@
 }
 /*}}}*/
-/*nearestinterp{{{1*/
+/*nearestinterp{{{*/
 double nearestinterp(double x1,double x2,double y1,double y2,double Q11,double Q12,double Q21,double Q22,double x,double y){
 	/*Nearest neighbor interpolation*/
Index: issm/branches/trunk-jpl-damage/src/c/modules/InterpFromGridToMeshx/InterpFromGridToMeshx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/InterpFromGridToMeshx/InterpFromGridToMeshx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/InterpFromGridToMeshx/InterpFromGridToMeshx.h	(revision 12878)
@@ -6,5 +6,5 @@
 #define _INTERPFROMGRIDTOMESHX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../toolkits/toolkits.h"
 #include "../../EnumDefinitions/EnumDefinitions.h"
